#include <QFile>
#include <QTextStream>
#include <QTextCodec>
#include "a2BCbbsTableTrim.h"
#include "a2BcConstants.h"

/*!
 *  RXgN^
 * 
 */
a2BCbbsTableTrim::a2BCbbsTableTrim(QWidget *parent) : QWidget(parent)
{

}

/*!
 *  fXgN^
 * 
 */
a2BCbbsTableTrim::~a2BCbbsTableTrim()
{

}

/*!
 *  f[^̃Zbg
 * 
 */
void a2BCbbsTableTrim::reset()
{
    mBbsTableAppend.clear();
}

/*!
 *  H
 * 
 */
bool a2BCbbsTableTrim::prepare(QString &arFileName)
{
    mBbsTableFileName = "";
    if (QFile::exists(arFileName) != true)
    {
        // t@C݂ȂꍇAG[
        return (false);
    }

    mBbsTableFileName = arFileName;

    QFile bbsTableFile(arFileName);
    if (!bbsTableFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        return (false);
    }
    QFile bbsTableBakFile(arFileName + ".back");
    if (!bbsTableBakFile.open(QIODevice::WriteOnly | QIODevice::Text))
    {
        bbsTableFile.close();
        return (false);
    }
  
    QTextStream in(&bbsTableFile);
    QTextStream out(&bbsTableBakFile);
    while (!in.atEnd())
    {
        QString line = in.readLine();
        if (line.contains("<!--a2BC-->") != true)
        {
            // f[^o͂
            out << line << endl;
        }
    }
    bbsTableBakFile.close();
    bbsTableFile.close();

    return (true);
}

/*!
 *  bbstable.html̉H{
 * 
 */
bool a2BCbbsTableTrim::output(void)
{
    QFile bbsTableBakFile(mBbsTableFileName + ".back");
    if (!bbsTableBakFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        return (false);
    }

    QFile bbsTableFile(mBbsTableFileName);
    if (!bbsTableFile.open(QIODevice::WriteOnly | QIODevice::Text))
    {
        bbsTableBakFile.close();
        return (false);
    }
  
   QTextCodec  *codec = QTextCodec::codecForName("Shift-JIS");
    QTextStream out(&bbsTableFile);
    QTextStream in(&bbsTableBakFile);
    QString     data;
    out << "<!--a2BC-->" << endl;
    int count = 0;
    for (QVector<QByteArray>::ConstIterator it = mBbsTableAppend.begin(); it != mBbsTableAppend.end(); it++)
    {
        if ((count % 50) == 0)
        {
            QString num;
            num.setNum(count / 50);
            data = codec->toUnicode("y<B>a2B");
            out << data;
            if ((count / 50) != 0)
            {
                out << "-" << num;
            }
            data = codec->toUnicode("</B>z");
            out << data << "<!--a2BC-->" << endl;
        }

        QString string = codec->toUnicode(*it);
        out << "<A HREF=";
        out << string << "</A>" << "<!--a2BC-->" << endl;
        
        count++;
    }
    data = codec->toUnicode("y<B>-----</B>z");
    out << data << "<!--a2BC-->" << endl;
    out << "<!--a2BC-->" << endl;
        
    while (!in.atEnd())
    {
        QString line = in.readLine();
        if (line.contains("<!--a2BC-->") != true)
        {
            // f[^o͂
            out << line << endl;
        }
    }
    bbsTableBakFile.close();
    bbsTableFile.close();
    
    QFile::remove(mBbsTableFileName + ".back");
    return (true);
}

/*!
 *  f[^̒ǉ
 * 
 */
void a2BCbbsTableTrim::append(QByteArray &arData)
{
    mBbsTableAppend.append(arData);
    return;
}

/*
 *  a2BC : a2B Connectivity
 *  Copyright (C) 2006- NNsi Project
 *  (see a2BC-src.txt for detail.)
 */
